package com.casic.dcms.mvp.model;

import com.casic.dcms.bean.ActionResultBean;
import com.casic.dcms.utils.retrofit.RetrofitServiceManager;

import rx.Observable;
import rx.Observer;
import rx.Subscription;
import rx.android.schedulers.AndroidSchedulers;
import rx.schedulers.Schedulers;

public class CleanToiletModelImpl implements ICleanToiletModel {

    private OnGetCleanResultListener listener;

    public CleanToiletModelImpl(OnGetCleanResultListener cleanResultListener) {
        this.listener = cleanResultListener;
    }

    /**
     * 数据回调接口
     */
    public interface OnGetCleanResultListener {
        void onSuccess(ActionResultBean resultBean);

        void onFailure(Throwable throwable);
    }

    @Override
    public Subscription sendRetrofitRequest(String toiletId, String userId, String lng, String lat, String cleanTime, String photo, String workContent) {
        Observable<ActionResultBean> observable = RetrofitServiceManager.getCleanToiletResult(toiletId, userId, lng, lat, cleanTime, photo, workContent);
        return observable.subscribeOn(Schedulers.io()).observeOn(AndroidSchedulers.mainThread()).subscribe(new Observer<ActionResultBean>() {
            @Override
            public void onCompleted() {

            }

            @Override
            public void onError(Throwable e) {
                if (e.getCause() != null) {
                    listener.onFailure(e);
                }
            }

            @Override
            public void onNext(ActionResultBean resultBean) {
                if (resultBean != null) {
                    listener.onSuccess(resultBean);
                }
            }
        });
    }
}
